// DCGSDebugObject.h
#ifndef _DCGSDEBUGOBJECT_H_
#define _DCGSDEBUGOBJECT_H_
#include "DCGSerror.h"
#include "DCGSexpression.h"

#define startMode Full

typedef enum DebugMode {
	Minimal,
	Standard,
	Full
} DebugMode;

class DebugObj {
public:
	DebugObj();
	~DebugObj();
	void setDebugMode(DebugMode mode);
	void setPosition(expression *res);
	DebugObj *copyExpression(expression **target,expression *source);
	long getLine();
	char *getFile();
	char *getFunction();
	DebugMode getMode();
#include "DCGSexpressionnew.h"
#include "DCGSexpressionCreate.h"
	void *codeGenFn1(expression *pgm);
	expression *parse1();
	expression **parse1(unsigned char *input, int *numExpressions);
	expression *parse1(unsigned char *input);
	expression **parse1(int *numExpressions);
	expression **parse1(char *input, int *numExpressions);
	expression *parse1(char *input);
	expression *parse1(FILE *input);
	expression **parse1(FILE *input, int *numExpressions);
	expression **parseFile1(char *input, int *numExpressions);
	expression *parseFile1(char *input);
	bool deleteSymbolDbg(expression **smb1, int flags=0);
	bool deleteSymbolDbg(char *smb, int flags);
};
DebugObj *initDebug(int line, char *function, char *file,int lineLast, char *functionLast, char *fileLast);
DebugObj *initDebugLast(int line, char *function, char *file);
DebugObj *initDebugFirst(int line, char *function, char *file);
DebugObj *initDebugNull();
#define newExpression initDebug(-100,NULL,NULL,__LINE__,__FUNCTION__,__FILE__)->newExpression1
#define codeGenFn initDebugFirst(__LINE__,__FUNCTION__,__FILE__)->codeGenFn1
#define parse initDebugFirst(__LINE__,__FUNCTION__,__FILE__)->parse1
#define parseFile initDebugFirst(__LINE__,__FUNCTION__,__FILE__)->parseFile1
#define rename(a) rename1(a,__LINE__,__FUNCTION__,__FILE__)
#endif
