// DCGSdefs.h
#ifndef _DCGSDEFS_H_
#define _DCGSDEFS_H_

class constvar;

typedef enum BINOP {
	BIN_ASSIGN,
	BIN_PLUS,
	BIN_MINUS,
	BIN_DIVIDE,
	BIN_REM,
	BIN_MULTIPLY,
	BIN_OR,
	BIN_XOR,
	BIN_AND,
	BIN_IFOR,
	BIN_IFAND,
	BIN_EQ,
	BIN_NEQ,
	BIN_SHL,
	BIN_SHR,
	BIN_GT,
	BIN_GE,
	BIN_LT,
	BIN_LE,
	BIN_INVALID
} BINOP;

typedef enum UNOP {
	UN_SIZEOF,			// sizeof
	UN_PLUS,			// +
	UN_MINUS,			// -
	UN_NOT,				// !
	UN_COMP,			// ~ (complement)
	UN_DEREF,			// *
	UN_ADDRESS,			// &
	UN_TERMINATE,
	// Casting operators
	UN_CHAR,
	UN_SHORT,
	UN_INT,
	UN_LONG,
	UN_FLOAT,
	UN_DOUBLE,
	UN_STRING,
	UN_PTR,
	UN_VOIDP,
	UN_INVALID
} UNOP;

typedef enum TEROP {
	TER_IF,
	TER_FOR,
	TER_INVALID
} TEROP;

typedef enum MULTIOP {
	MUL_SEQ,
	MUL_BLOCK,
	MUL_INVALID
} MULTIOP;

typedef enum LOOPOP {
	DO_FOR,
	DO_WHILE,
	DO_UNTIL,
	DO_INVALID
} LOOPOP;

typedef enum LOOPOP1 {
	LOOP_FOR
} LOOPOP1;
typedef enum LOOPOP2 {
	LOOP_WHILE,
	LOOP_UNTIL
} LOOPOP2;

typedef enum RETURNOP {
	RETURN
} RETURNOP;
typedef enum CONSTANTOP {
	CONSTANT
} CONSTANTOP;
typedef enum VARIABLEOP {
	VARIABLE
} VARIABLEOP;

typedef enum FUNCTIONOP {
	FUNCTION
} FUNCTIONOP;

typedef enum ENTRYOP {
	ENTRY
} ENTRYOP;

typedef enum CALLOP {
	CALL
} CALLOP;

extern unsigned int callopv[];

typedef enum PARMOP {
	PARAMETER
} PARMOP;

typedef enum NULLOP {
	NULL_BREAK,
	NULL_CONTINUE,
	NULL_TERMINATE,
	NULL_INVALID
} NULLOP;

typedef enum LISTOP {
	LIST_CALL
} LISTOP;

typedef enum VAROP {
	VARCHAR,
	VARSHORT,
	VARINT,
	VARLONG,
	VARFLOAT,
	VARDOUBLE,
	VARPTR,
	VARULONG
} VAROP;

typedef enum Const {
	CHAR,
	SHORT,
	INT,
	LONG,
	FLOAT,
	DOUBLE,	
	STRING,	
	VOIDP=8,
	PTR,
	EXPRP,
	EXPRESSION,	
	ULONG,
	ERROR
} Const;

#define EVALDEF constvar &eval()

typedef enum classes {
	clNone = 0,	
	//
	clExpr,	
	clNullExpr,	
	clBinExpr,
	clUnExpr,
	clReturnExpr,	
	clTrExpr,	
	clSeqExpr,	
	clLoopExpr,
	clFunctionExpr,
	clEntryExpr,
	clCallExpr,	
	clParm,	
	//
	clConstant,	
	clConstChar,
	clConstShort,
	clConstInt,	
	clConstLong,
	clConstFloat,
	clConstDouble,
	clConstString,
	clConstPtr,	
	//
	clVariable,	
	clVarChar,	
	clVarShort,	
	clVarInt,
	clVarLong,
	clVarFloat,	
	clVarDouble,
	clVarString,
	clBAD,
	clVarVar,
	clVarPtr,
	clInvalid
} classes;

typedef void *FN(int,void **);
#endif

